
function inds = draw_from_windows(data_len, window_vec)

    window_vec = round(window_vec);

    D = data_len;
    indicator = window_vec;

    nwindows = ceil(D / sqrt(D));
    window_size = ceil(D / nwindows);

    assert(nwindows == length(indicator));

    window_starts = (1:nwindows) - 1;
    window_starts = window_starts .* window_size + 1;

    inds = [];
    for i = 1:nwindows

        begin_ = window_starts(i);
        end_   = begin_ + window_size - 1;
        end_   = min(end_, D);

        nfeatures = indicator(i);
        nfeatures = max(nfeatures, 0);
        nfeatures = min(nfeatures, end_ - begin_ + 1);

        indices = randperm(end_ - begin_ + 1, nfeatures) + begin_ - 1;
        inds = [inds indices];
    end

end
