function p = empty_params()

% k_folds
%     Use 5 or 10
% svm_kernel
%     0 - linear, 2 - rbf, other - https://www.csie.ntu.edu.tw/~cjlin/libsvm/
% use_tsne
%     XXX This should be mutually exclusive with repr_type 'manifold'!
%     It merely reorders the genes with no walking on manifold.
%     Use either 'use_tsne' or repr 'manifold'.
% c
%     svm_c
% gamma
%     TODO
% mirna_alpha
%     The formula is:
%     fitness = score - (max(0, nfeatures - param.t) * param.mirna_alpha);
%     e.g.,
%     score - (max(0, nfeatures - 10) * alpha)
% t
%     "Target number of features" -- see above
% svm_metric
%     Valid: 'f', 'acc'
% classifier
%     'svm', 'knn', 'adaboost', 'randomforest', 'logistic', 'naivebayes'
% n_workers
%     TODO
% repr_name
%     Valid: 'fixed', 'manifold', TODO
%     'manifold' is the new one for {sne,tsne}{1,2}
% repr_d
%     For repr 'manifold'
% manifold_name
%     For repr 'manifold'
%     Acceptable: 'sne1', 'sne2', 'tsne1', tsne2'

p = struct();
p.data_file_ind   = 60; % full 10-class miRNA
p.use_tsne        = false;
p.nworkers        = 1;
p.max_it          = 10000;
p.save_logs_niter = 1; % Output logs every niter iterations.
p.k_folds         = 5;
p.classifier      = 'svm';
p.svm_kernel      = 2;

p.repr_name       = 'manifold';
p.repr_d          = 50;
p.manifold_name   = 'sne1';
p.manifold_d      = 2;
p.cached_manifold = false;

p.c               = 1.0;
p.gamma           = NaN;
p.mirna_alpha     = 5;
p.t               = 5;
p.svm_metric      = 'acc';
p.knn_k           = 5;

p.silent          = false;
p.randi           = randi([100000, 999999]);
p.start_time      = datestr(clock);
p.logdir          = ['results/', datestr(now, 'yyyy-mm-dd')];

end
