function [data_set, data_labels, data_fname] = fetch_data(ind)

data_set_files{60} = 'data/mirna2/full.data';
data_set_files{61} = 'data/mirna2/01.data';
data_set_files{62} = 'data/mirna2/02.data';
data_set_files{63} = 'data/mirna2/03.data';
data_set_files{64} = 'data/mirna2/04.data';
data_set_files{65} = 'data/mirna2/05.data';
data_set_files{66} = 'data/mirna2/06.data';
data_set_files{67} = 'data/mirna2/07.data';
data_set_files{68} = 'data/mirna2/08.data';
data_set_files{69} = 'data/mirna2/09.data';
data_set_files{70} = 'data/mirna2/10.data';
data_set_files{71} = 'data/mirna2/full2class.data';

if ind >= 10000
    data_fname = data_set_files{60};
else
    data_fname = data_set_files{ind};
end

% NOTE Transpose only certain data files!
if ind >= 10000
    % Numbers 1xx00 denote the first class.
    % Numbers 100xx denote the other class.
    % The two should be different.
    data_set = dlmread(data_fname, ',');
    data_labels = data_set(:, end);
    data_set = data_set(:, 1:end-1);

    % Select class numbers.
    class1_label = mod(fix(ind/100),100);
    class2_label = mod(ind,100);

    biclass_inds = [find(data_labels == class1_label)
                    find(data_labels == class2_label)
                    find(data_labels == 11)];

    data_labels = data_labels(biclass_inds);
    data_set = data_set(biclass_inds,:);

elseif ind >= 50
    data_set = dlmread(data_fname, ',');
    data_labels = data_set(:, end);
    data_set = data_set(:, 1:end-1);
elseif ind >= 30 % miRNA
    data_set = dlmread(data_fname, ',');
    data_labels = data_set(:,end);
    data_set = data_set(:, 1:end-1);
elseif ind >= 20
    load(data_fname);
    data_set = data;
    data_labels = data_set(:,1);
    data_set = data_set(:, 2:end);
else
    data_set = load(data_fname)';
    data_labels = data_set(:,1);
    data_set = data_set(:, 2:end);
end

end
