function [data_set, data_labels, data_fname] = fetch_data(ind)

data_set_files{ 1} = 'data/indra/armstrong-2002-v2_database.data';
data_set_files{ 2} = 'data/indra/chowdary-2006_database.data';
data_set_files{ 3} = 'data/indra/liang-2005_database.data';
data_set_files{ 4} = 'data/indra/nutt-2003-v1_database.data';
data_set_files{ 5} = 'data/indra/ramaswamy-2001_database.data';
data_set_files{ 6} = 'data/indra/su-2001_database.data';
data_set_files{ 7} = 'data/indra/yeoh-2002-v2_database.data';
data_set_files{ 8} = 'data/indra/bhattacharjee-2001_database.data';
data_set_files{ 9} = 'data/indra/laiho-2007_database.data';
data_set_files{10} = 'data/indra/pomeroy-2002-v2_database.data';
data_set_files{11} = 'data/indra/risinger-2003_database.data';
data_set_files{12} = 'data/indra/west-2001_database.data';
data_set_files{13} = 'data/indra/laiho-2007_database.data'; % Copied to another ind to distinguish from old 'corrupted' computations

data_set_files{20} = 'data/gems/Brain_Tumor1.mat';
data_set_files{21} = 'data/gems/9_Tumors.mat';

data_set_files{30} = 'data/mirna/migca.data';
data_set_files{31} = 'data/mirna/breast.data';
data_set_files{32} = 'data/mirna/colon.data';
data_set_files{33} = 'data/mirna/kidney.data';
data_set_files{34} = 'data/mirna/lung.data';
data_set_files{35} = 'data/mirna/prostate.data';
data_set_files{36} = 'data/mirna/uterus.data';

data_set_files{50} = '/pio/scratch/1/animals_with_attrs/Animals_with_Attributes/decaf.csv';

data_set_files{60} = 'data/mirna2/full.data';
data_set_files{61} = 'data/mirna2/01.data';
data_set_files{62} = 'data/mirna2/02.data';
data_set_files{63} = 'data/mirna2/03.data';
data_set_files{64} = 'data/mirna2/04.data';
data_set_files{65} = 'data/mirna2/05.data';
data_set_files{66} = 'data/mirna2/06.data';
data_set_files{67} = 'data/mirna2/07.data';
data_set_files{68} = 'data/mirna2/08.data';
data_set_files{69} = 'data/mirna2/09.data';
data_set_files{70} = 'data/mirna2/10.data';
data_set_files{71} = 'data/mirna2/full2class.data';

data_set_files{81} = 'data/mirna2/01.data.trimmed.csv';
data_set_files{82} = 'data/mirna2/02.data.trimmed.csv';
data_set_files{83} = 'data/mirna2/03.data.trimmed.csv';
data_set_files{84} = 'data/mirna2/04.data.trimmed.csv';
data_set_files{85} = 'data/mirna2/05.data.trimmed.csv';
data_set_files{86} = 'data/mirna2/06.data.trimmed.csv';
data_set_files{87} = 'data/mirna2/07.data.trimmed.csv';
data_set_files{88} = 'data/mirna2/08.data.trimmed.csv';
data_set_files{89} = 'data/mirna2/09.data.trimmed.csv';
data_set_files{90} = 'data/mirna2/10.data.trimmed.csv';
data_set_files{91} = 'data/mirna2/full2class_2trim.data.trimmed.csv';
data_set_files{92} = 'data/mirna2/full2class_4trim.data.trimmed.csv';

data_set_files{161} = 'data/mirna2/01.data.normjitter.csv';
data_set_files{162} = 'data/mirna2/02.data.normjitter.csv';
data_set_files{163} = 'data/mirna2/03.data.normjitter.csv';
data_set_files{164} = 'data/mirna2/04.data.normjitter.csv';
data_set_files{165} = 'data/mirna2/05.data.normjitter.csv';
data_set_files{166} = 'data/mirna2/06.data.normjitter.csv';
data_set_files{167} = 'data/mirna2/07.data.normjitter.csv';
data_set_files{168} = 'data/mirna2/08.data.normjitter.csv';
data_set_files{169} = 'data/mirna2/09.data.normjitter.csv';
data_set_files{170} = 'data/mirna2/10.data.normjitter.csv';
data_set_files{171} = 'data/mirna2/full2class.data.normjitter.csv';


if ind >= 10000
    data_fname = data_set_files{60};
else
    data_fname = data_set_files{ind};
end

% NOTE Transpose only certain data files!
if ind >= 10000
    % Numbers 1xx00 denote the first class.
    % Numbers 100xx denote the other class.
    % The two should be different.
    data_set = dlmread(data_fname, ',');
    data_labels = data_set(:, end);
    data_set = data_set(:, 1:end-1);

    % Select class numbers.
    class1_label = mod(fix(ind/100),100);
    class2_label = mod(ind,100);

    biclass_inds = [find(data_labels == class1_label)
                    find(data_labels == class2_label)
                    find(data_labels == 11)];

    data_labels = data_labels(biclass_inds);
    data_set = data_set(biclass_inds,:);

elseif ind >= 50
    data_set = dlmread(data_fname, ',');
    data_labels = data_set(:, end);
    data_set = data_set(:, 1:end-1);
elseif ind >= 30 % miRNA
    data_set = dlmread(data_fname, ',');
    data_labels = data_set(:,end);
    data_set = data_set(:, 1:end-1);
elseif ind >= 20
    load(data_fname);
    data_set = data;
    data_labels = data_set(:,1);
    data_set = data_set(:, 2:end);
else
    data_set = load(data_fname)';
    data_labels = data_set(:,1);
    data_set = data_set(:, 2:end);
end

end
