function subset_ind_array = snr(data_set, data_labels, max_nclusters)

km_niters = 100;

% Consider feature subsets up to this size
subset_ind_array = cell(max_nclusters, 1);

[ntrain, D] = size(data_set);

classes = unique(data_labels);
S = zeros(length(classes), D);

for c = 20:max_nclusters

    if (mod(c, 10) == 0)
        fprintf(1, '.');
    end

    % Do k-means with 'c' classes and 500 iterations
    inds = kmeans(data_set, km_niters, c);
    inds = unique(inds(inds >= 1));

    subset_ind_array{c} = inds;
end
    fprintf(1, '\n');
end
