function Tperm = welch_test(data_set, data_labels, niter)
% The lower p value, the more predictive power a feature has.

% Taken from "Nonparametric methods for identifying
% differentially expressed genes in microarray data".

% foo

[ntrain, D] = size(data_set);

% bar

classes = unique(data_labels);
Tobj = zeros(length(classes), D);
Tperm = zeros(length(classes), D);

for iter = 1:(niter+1)

    if mod(iter, 100) == 0
        fprintf(1, '.');
    end

    if iter > 1
        data_set = data_set(randperm(ntrain), :);
    end
    
    for i = 1:length(classes)
        this_class_inds = find(data_labels == classes(i));
        other_class_inds = find(data_labels ~= classes(i));
    
        this_data = data_set(this_class_inds, :);
        other_data = data_set(other_class_inds, :);
    
        for d = 1:D

            [~,h,~,~] = ttest2(this_data(:,d), other_data(:,d), 'Vartype','unequal');
            if iter == 1
                Tobj(i, d) = h;
            else
                Tperm(i,d) = Tperm(i,d) + (h > Tobj(i,d));
            end
        end
    end

end

fprintf(1, '\n');

Tperm = 1.0 * Tperm / niter;
size(Tperm)
