
function X = random_population(N, D, num_instances, indiv_type, data_set, data_labels)

% Feature reduction.
% X = randi(2, N, D) - 1;

% Feature + instance reduction.
% X = randi(2, N, D+num_instances) - 1;

SNR = snr(data_set, data_labels);
MAX = max(SNR);
mmax = max(MAX);

X = zeros(N, D+1);
for i = 1:D
    X(:, i) = normrnd(MAX(i)/mmax, 0.3, N, 1);
end

% threshold
X(:, end) = rand(N, 1);
X(:, end) = 0.3 + (0.7 * rand(N, 1));

X = max(X, 0.0);
X = min(X, 1.0);

for i = 1:100
    A(i) = sum((X(i, 1:end-1) >= X(i, end)));
end
A

return

if indiv_type == 0
    
    if ~select_instances
        X = draw_boolean_rows(N, D);
    else
        X = [ draw_boolean_rows(N, D) draw_boolean_rows(N, num_instances) ];
    end

elseif indiv_type == 2
    nwindows = ceil(D / sqrt(D));
    window_size = ceil(D / nwindows);
    X = randi(window_size, N, nwindows);

elseif indiv_type == 3

    % Random string of 0-1 real numbers, D+1 of them (the last one denotes the threshold).
    X = rand(N, D+1);
end

end % random_population

function X = draw_boolean_rows(num, len)
% Draws a boolean matrix of size num x len, each row having at least one 1.

X = [ ones(num, 1) (randi(2, num, len-1) - 1) ];

for i = 1:num
    perm = randperm(len);
    X(i, :) = X(i, perm);
end

end % draw_boolean_rows

