function obj = ReprFixed_init(D, feature_order)

obj = struct();

obj.feature_order = (1:199);
if exist('feature_order', 'var')
    obj.feature_order = feature_order;
    fprintf(1, 'Set feature order\n');
end;

% private data members
obj.D = D;

% public data members
obj.name = 'fixed';
obj.log_name = '_FIXED_';
obj.len = D;
obj.de_FVr_minbound = zeros(1, D);
obj.de_FVr_maxbound = ones(1, D);

% public methods
obj.rand_pop = @ReprFixed_rand_pop;
obj.feature_num = @ReprFixed_feature_num;
obj.feature_list = @ReprFixed_feature_list;
obj.gene_list = @ReprFixed_gene_list;
obj.empty_indiv = @ReprFixed_empty_indiv;
end

function X = ReprFixed_rand_pop(obj, N)
X = rand(N, obj.D);
end

function flist = ReprFixed_feature_list(obj, indiv)
flist = find(indiv >= 0.5);
flist = obj.feature_order(flist);
end

function n = ReprFixed_feature_num(obj, indiv)
flist = obj.feature_list(obj, indiv);
n = length(flist);
assert(n <= obj.D);
end

function glist = ReprFixed_gene_list(obj, indiv)
glist = obj.feature_list(obj, indiv);
end
