function S = mysnr(data_set, data_labels)

[ntrain, D] = size(data_set);

classes = unique(data_labels);
S = zeros(length(classes), D);

for i = 1:length(classes)
    this_class_inds = find(data_labels == classes(i));
    other_class_inds = find(data_labels ~= classes(i));

    this_data = data_set(this_class_inds, :);
    other_data = data_set(other_class_inds, :);

    S(i, :) = abs((mean(this_data) - mean(other_data)) ./ (std(this_data) + std(other_data)));
end
