function R = ranksum_test(data_set, data_labels)
% The lower p value, the more predictive power a feature has.

[ntrain, D] = size(data_set);

classes = unique(data_labels);
R = zeros(length(classes), D);

for i = 1:length(classes)
    this_class_inds = find(data_labels == classes(i));
    other_class_inds = find(data_labels ~= classes(i));

    this_data = data_set(this_class_inds, :);
    other_data = data_set(other_class_inds, :);

    for d = 1:D
        this_col = this_data(:, d);
        other_col = other_data(:, d);
        R(i, d) = ranksum(this_col, other_col);
    end
end
