function obj = ReprDummy_init(D)
% Chromosome consists of three parts: [ real part ][ 0-1 real part ][ threshold ]
% The real part has length wnum and holds feature number for each window
% The 0-1 real part has length wnum and says whether to take the corresponding feature
% from the real part.
% The threshold is a single number taken from 0-1.
% Total length: 2*wnum + 1

obj = struct();

obj.D = D;

obj.name = 'dummy';
obj.len = D;
obj.de_FVr_minbound = zeros(1, D);
obj.de_FVr_maxbound = ones(1, D) * D;
obj.rand_pop = @ReprDummy_rand_pop;
obj.feature_num = @ReprDummy_feature_num;
obj.feature_list = @ReprDummy_feature_list;

end

function X = ReprDummy_rand_pop(obj,N)
X = repmat(1:obj.D, N, 1);
end

function n = ReprDummy_feature_num(obj,indiv)
n = obj.D;
end

function flist = ReprDummy_feature_list(obj,indiv)
flist = 1:obj.D;
end
