function obj = ReprFixlen2_init(D)

obj = struct();

% private data members
obj.D = D;
obj.fixlen = 20;

% public data members
obj.name = 'fixlen2';
obj.log_name = '_FIXLEN2_';
obj.len = obj.D;
obj.de_FVr_minbound = zeros(1, obj.D);
obj.de_FVr_maxbound = ones(1, obj.D);

% public methods
obj.rand_pop = @ReprFixlen2_rand_pop;
obj.feature_num = @ReprFixlen2_feature_num;
obj.feature_list = @ReprFixlen2_feature_list;
obj.gene_list = @ReprFixlen2_gene_list;
obj.empty_indiv = @ReprFixlen2_empty_indiv;
end

function X = ReprFixlen2_rand_pop(obj, N)
X = rand(N, obj.D);
end

function flist = ReprFixlen2_feature_list(obj, indiv)
flist = round(indiv(1:obj.fixlen));
flist = min(max(indiv,1),obj.D);
end

function n = ReprFixlen2_feature_num(obj, indiv)
n = obj.fixlen
end

function glist = ReprFixlen2_gene_list(obj, indiv)
glist = obj.feature_list(obj, indiv);
end
