function obj = ReprFixlen_init(D)

obj = struct();

% private data members
obj.D = D;
obj.fixlen = 5;

% public data members
obj.name = 'fixlen';
obj.log_name = '_FIXLEN_';
obj.len = obj.fixlen;
obj.de_FVr_minbound = ones(1, obj.fixlen) / -2.0;
obj.de_FVr_maxbound = ones(1, obj.fixlen) * 1.0 * obj.D + 0.5;

% public methods
obj.rand_pop = @ReprFixlen_rand_pop;
obj.feature_num = @ReprFixlen_feature_num;
obj.feature_list = @ReprFixlen_feature_list;
obj.gene_list = @ReprFixlen_gene_list;
obj.empty_indiv = @ReprFixlen_empty_indiv;
end

function X = ReprFixlen_rand_pop(obj, N)
X = rand(N, obj.fixlen) * obj.D;
end

function flist = ReprFixlen_feature_list(obj, indiv)
flist = round(indiv);
flist = min(max(flist,1),obj.D);
flist = unique(flist);
end

function n = ReprFixlen_feature_num(obj, indiv)
flist = obj.feature_list(obj, indiv);
n = length(flist);
assert(n <= obj.D);
end

function glist = ReprFixlen_gene_list(obj, indiv)
glist = obj.feature_list(obj, indiv);
end
