function obj = ReprOhOne_init(D)

obj = struct();

% private data members
obj.D = D;

% public data members
obj.name = 'ohone';
obj.log_name = '_OHONE_';
obj.len = D + 1;
obj.de_FVr_minbound = zeros(1, D+1);
obj.de_FVr_maxbound = ones(1, D+1);

% public methods
obj.rand_pop = @ReprOhOne_rand_pop;
obj.feature_num = @ReprOhOne_feature_num;
obj.feature_list = @ReprOhOne_feature_list;
obj.gene_list = @ReprOhOne_gene_list;
obj.empty_indiv = @ReprOhOne_empty_indiv;
end

function X = ReprOhOne_rand_pop(obj, N)
X = rand(N, obj.D+1);
end

function flist = ReprOhOne_feature_list(obj, indiv)
thresh = indiv(end);
flist = find(indiv(1:(end-1)) >= thresh);
end

function n = ReprOhOne_feature_num(obj, indiv)
flist = obj.feature_list(obj, indiv);
n = length(flist);
assert(n <= obj.D);
end

function glist = ReprOhOne_gene_list(obj, indiv)
glist = obj.feature_list(obj, indiv);
end
