function X = ReprOther()

%%%%%%%%%% iceccs_demo.m

% 0 - use 0/1 to indicate feature
% 1 - use a single number denoting the number of features
% 2 - use sqrt(D) clusters denoting sqrt(D) features from each one
% 3 - use 0/1 to indicate feature with an adaptive threshold
indiv_type = 3;

% XXX XXX XXX XXX XXX 
if indiv_type == 2
    nwindows = ceil(D / sqrt(D));
    window_size = ceil(D / nwindows);
    d_reduced = nwindows;
end

% T = ceil(sqrt(D)); % Number of thresholds for evenly placed windows
if isstr(window_num) && window_num == 'sqrt'
    T = ceil(sqrt(D));
elseif window_num == 0
    T = 0;
else
    T = ceil(D / window_num);
end

if optimizer_ind == 3 % DE + t-sne
    % Create a N x real_encoding_feature_num vector of real numbers in [0.5; D+0.5]
    X = rand(N, real_encoding_feature_num) * D + 0.5;

    if GLOB_sort_indivs
        X = sort(X,2);
    end

elseif optimizer_ind == 4


% X = random_population(N, D, 0, indiv_type, data_set, data_labels);


else % All the other cases
    X = indiv_thresh_pop(N, D, T, data_set, data_labels);
    d_reduced = size(X, 2);
end

if optimizer_ind == 4
    history.best_indiv = zeros(max_it, wnum + wnum + 1);
elseif optimizer_ind == 3
    history.best_indiv = zeros(max_it, real_encoding_feature_num);
else
    history.best_indiv = zeros(max_it, D+T);
end

end

function X = indiv_thresh_pop(N, D, T, data_set, data_labels)

SNR = snr(data_set, data_labels);
MAX = max(SNR);
mmax = max(MAX);

X = zeros(N, D+T);
for i = 1:D
    X(:, i) = normrnd(MAX(i)/mmax, 0.3, N, 1);
end

% threshold(s)
X(:, D+1:end) = rand(N, T);
% X(:, D+1:end) = 0.3 + (0.7 * rand(N, T));
X(:, D+1:end) = 0.6 + (0.4 * rand(N, T));

X = max(X, 0.0);
X = min(X, 1.0);

A = thresh_feature_count(X, T);

A

end

function X = indiv_thresh_pop(N, D, T, data_set, data_labels)

SNR = snr(data_set, data_labels);
MAX = max(SNR);
mmax = max(MAX);

X = zeros(N, D+T);
for i = 1:D
    X(:, i) = normrnd(MAX(i)/mmax, 0.3, N, 1);
end

% threshold(s)
X(:, D+1:end) = rand(N, T);
% X(:, D+1:end) = 0.3 + (0.7 * rand(N, T));
X(:, D+1:end) = 0.6 + (0.4 * rand(N, T));

X = max(X, 0.0);
X = min(X, 1.0);

A = thresh_feature_count(X, T);

A

end


function [low, hi] = thresh_bounds(D, T, t)

low = round(D/T) * (t-1) + 1;
hi  = min(round(D/T) * t, D);

end


%%%%%%%%%%%%%%%%%%%%%%%%% inner loop

global GLOB_sort_indivs;
global GLOB_halfway_empty_feats;
global GLOB_optimizer_ind;
global GLOB_wsize;
global GLOB_wnum;

wsize = GLOB_wsize;
wnum = GLOB_wnum;

[ntrain,D] = size(X);
D = D - T;

if GLOB_optimizer_ind == 4
    fitness_mode = 5;
elseif real_indiv_values
    fitness_mode = 4;
else
    fitness_mode = 3;
end

if fitness_mode == 0
    inds = 1:D;
    inds = inds(indicator ~= 0);
elseif fitness_mode == 1
    target_D = indicator(1);
    inds = randperm(D);
    inds = inds(1:target_D);
elseif fitness_mode == 2
    inds = draw_from_windows(D, indicator);
elseif fitness_mode == 3

    % Adaptive threshold and 0-1 real weights for features.
    inds = [];
    for j = D+1:D+T
        threshold = indicator(j);
        [low, hi] = thresh_bounds(D, T, j-D);
        indss = low:hi;
        indss = indss(indicator(low:hi) >= threshold);
        inds = [inds indss];
    end
elseif fitness_mode == 4

    if GLOB_halfway_empty_feats
        % Here treat values closer to halves are made into zeros.
        inds = round(indicator * 2);
        inds(mod(inds,2) == 1) = 0;
        inds = inds / 2;
    else
        inds = round(indicator);
    end

    inds(inds > D) = 0; % Now all 'empty' features have index 0.

    % Remove 0s and duplicates.
    inds(inds == 0) = [];
    inds = unique(inds);
    % Get the indexes of all elements excluding duplicates
    [~, idxs, ~] = unique(inds, 'last'); % Or 'first'
    % Resort indexes and apply for input vector
    inds = inds(sort(idxs));

% XXX XXX XXX XXX XXX XXX XXX XXX
elseif fitness_mode == 5
% XXX XXX XXX XXX XXX XXX XXX XXX

    inds = round(indicator(1:wnum));
    filter = indicator((wnum+1):(2*wnum));
    thresh = indicator(end);

    if length(inds) ~= length(filter)
        fprintf(1, 'DUPA\n');
        wysyp_sie;
    end

    % If the highest one is too large, then bring it down.
    inds = min(inds, D);
    inds = max(inds, 1);

    inds_to_take = inds(filter > thresh);
    inds = inds_to_take;
end

% P = pca(X, 3);

% XXX Surpress SVM output.
% model = svmtrain(train_labels, XX, '-t 0');

%%%%%%%%%%%%%%%%%%%% DE
if GLOB_optimizer_ind == 4
    total_fnum = total_fnum + Repr_comb_num_feats(FM_ui(i, :), D);
elseif real_indiv_values
    total_fnum = total_fnum + num_features(FM_ui(i, :), D);
else
    total_fnum = total_fnum + sum(FM_ui(i, 1:end-1) > FM_ui(i, end));
end

   if GLOB_optimizer_ind == 4
       history.best_fnum(I_iter) = Repr_comb_num_feats(FM_ui(i, :), D);
   elseif real_indiv_values 
       history.best_fnum(I_iter) = num_features(FM_ui(i, :), D);
   else
       history.best_fnum(I_iter) = sum(FM_ui(max_ind, 1:end-1) > FM_ui(max_ind, end));
   end

%%%%%%%%%%%%%%%%%%%%%%%% print best


else

    if GLOB_optimizer_ind == 4

        indicator = best;
        inds = round(indicator(1:wnum));
        filter = indicator((wnum+1):(2*wnum));
        thresh = indicator(end);

        if length(inds) ~= length(filter)
            fprintf(1, 'DUPA\n');
            wysyp_sie;
        end

        % If the highest one is too large, then bring it down.
        inds = min(inds, D);
        inds = max(inds, 1);

        inds_to_take = inds(filter > thresh);
        inds = inds_to_take;
        feats = inds_to_take;

    else
        if GLOB_halfway_empty_feats
        % Here treat values closer to halves as zeros. 
            inds = round(best * 2);
            inds(mod(inds,2) == 1) = 0;
            int_best = inds / 2;
        else
            int_best = round(best);
        end

        feats = int_best(int_best > 0);
        feats = feats(feats <= D);

        % Get the indexes of all elements excluding duplicates
        [~, idxs, ~] = unique(feats, 'last'); % Or 'first'
        % Resort indexes and apply for input vector
        feats = feats(sort(idxs));
    end


    % fprintf(1, '%d\tBest attrs (acc %.6f): [%d] %s\n',...
    %         iteration, fit, length(feats), num2str(print_feats));
end

% fprintf(1, 'Best attrs (acc %.2f): [%s]\n', fit, regexprep(num2str(features), '\s+', ' '));

%%%%%%%%%%%%%%%%%%%%%%%%%%%% save log

global GLOB_sort_indivs;
global GLOB_halfway_empty_feats;
global GLOB_tsne; % Same as optimizer ind = 4.
global GLOB_max_fnum;
global GLOB_optimizer_ind;
global GLOB_wsize;

extra_params = '_';
if GLOB_optimizer_ind == 4
    extra_params = strcat(extra_params, '_COMB_wsize_', num2str(GLOB_wsize), '_');
else
    if GLOB_tsne
        extra_params = strcat(extra_params, 'TSNE_');
    end
    if GLOB_sort_indivs
        extra_params = strcat(extra_params, 'SORT_');
    end
    if GLOB_halfway_empty_feats
        extra_params = strcat(extra_params, 'HALF_');
    end
end
extra_params = strcat(extra_params, num2str(GLOB_max_fnum), '_');

