function obj = ReprRandAndPerm_init(D, len)

obj = struct();

% private data members
obj.D = D;
obj.len = len;

% public data members
obj.name = 'randandperm';
obj.log_name = '_RANDANDPERM_';
obj.len = obj.len;
obj.de_FVr_minbound = ones(1, obj.len) / -2.0;
obj.de_FVr_maxbound = ones(1, obj.len) * 1.0 * obj.D + 0.5;

% public methods
obj.rand_pop = @ReprRandAndPerm_rand_pop;
obj.feature_num = @ReprRandAndPerm_feature_num;
obj.feature_list = @ReprRandAndPerm_feature_list;
obj.gene_list = @ReprRandAndPerm_gene_list;
obj.empty_indiv = @ReprRandAndPerm_empty_indiv;
end

function X = ReprRandAndPerm_rand_pop(obj, N)
X = rand(N, obj.len) * obj.D;
end

function flist = ReprRandAndPerm_feature_list(obj, indiv)
flist = round(indiv);
flist = min(max(flist,1),obj.D);
flist = unique(flist);
end

function n = ReprRandAndPerm_feature_num(obj, indiv)
flist = obj.feature_list(obj, indiv);
n = length(flist);
assert(n <= obj.D);
end

function glist = ReprRandAndPerm_gene_list(obj, indiv)
glist = obj.feature_list(obj, indiv);
end
