function Y = random_subset(X)
% Returns the data restricted to a random subset of dimensions
% (the data DxN is restricted to D'xN, where D' <= D.

[N,D] = size(X);

filt = random_filter(D);
inds = 1:D;
inds = inds(filt ~= 0);

Y = X(:, inds);

fprintf(1, 'Chosen %d / %d dimensions\n', size(inds, 2), D);

end
